<template>
  <div class="documents">
    <div v-if="USER.roles.indexOf('ADMIN') >= 0" class="upload">
      <div
        v-show="!file"
        class="upload"
        @dragover.prevent="dragOver"
        @dragleave.prevent="dragLeave"
        @drop.prevent="drop($event)"
      >
        <div class="beforeUpload">
          <input
            type="file"
            style="z-index: 1"
            ref="uploadInput"
            @change="previewFiles"
            multiple
          />
          <p>Нажмите, чтобы загрузить или перетащите файл сюда</p>
        </div>
      </div>
      <div v-show="!file" class="mt-4">
        <p class="my-0">или файл по ссылке</p>
        <div class="d-flex">
          <v-text-field v-model="url" label="Ссылка на файл"/>
          <v-btn @click="sendFile" color="primary">Загрузить</v-btn>
        </div>
      </div>
      <v-row v-if="file" class="my-5 mr-2">
        <v-col sm="2">
          <v-card>
            <v-card-subtitle>{{file.name}}</v-card-subtitle>
            <v-card-subtitle>{{file.size / 1024 | toFixed}}кб</v-card-subtitle>
            <img src="" alt="">
            <br>
            <div style="padding: 10px" v-if="uploadPercentage>0">
              <progress style="width: 100%" max="100" :value.prop="uploadPercentage"></progress>
              <div class="d-flex" :style="{
                color: 'green',
                opacity: uploadPercentage < 25 ? '0.30' : uploadPercentage >= 25 && uploadPercentage < 50 ? '0.50' : uploadPercentage >= 50 && uploadPercentage < 75 ? '0.75' : uploadPercentage >= 75 && uploadPercentage < 100 ? '1' : '1'
              }">Загрузка: {{uploadPercentage}}%</div>
            </div>
            <br>
          </v-card>
        </v-col>
        <v-col sm="2">
          <v-btn @click="sendFile" color="primary" class="mt-2">Загрузить</v-btn>
          <v-btn @click="resetInput" color="primary" class="mt-2">Очистить</v-btn>
        </v-col>
      </v-row>
    </div>
    <div class="file-upload-prev-wrap">
      <v-row class="my-5 mr-2" style="overflow: auto;">
        <v-col v-for="docs in documents" :key="docs._id" sm="2" class="docs-wrap">
          <v-hover v-slot="{ hover }">
            <a target="_blank" :href="urlAddress+docs.destination">
              <v-card class="docs">
                <v-card-subtitle>{{docs.name}}</v-card-subtitle>
                <v-btn @click.prevent="deleteDocument(docs)" v-if="hover" color="primary" class="delete-btn"><span class="mr-2">Удалить</span><v-icon>mdi-delete</v-icon></v-btn>
                <img v-if="docs.extension === 'jpg' || docs.extension === 'jpeg' || docs.extension === 'png'" src="../assets/img/icons/jpg-file.png" alt="">
                <img v-else-if="docs.extension === 'pdf'" src="../assets/img/icons/pdf-file.png" alt="">
                <img v-else-if="docs.extension === 'doc' || docs.extension === 'docx'" src="../assets/img/icons/doc-file.png" alt="">
                <img v-else-if="docs.extension === 'ppt'" src="../assets/img/icons/ppt-file.png" alt="">
                <img v-else-if="docs.extension === 'txt' || docs.extension === 'plain'" src="../assets/img/icons/txt-file.png" alt="">
                <img v-else-if="docs.extension === 'xls'" src="../assets/img/icons/xls-file.png" alt="">
                <img v-else src="../assets/img/icons/document-type-definition.png" alt="">
              </v-card>
            </a>
          </v-hover>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
import apiAddress from '@/API/address'
import urlAddress from '@/API/url'
import store from '@/vuex/store'
import toFixed from './filteres/toFixed'
import { mapGetters } from 'vuex'
import api from '@/API/api'

export default {
  name: 'Documents',
  data: () => ({
    name: '',
    url: '',
    file: null,
    documents: [],
    uploadPercentage: 0
  }),
  created () {
    this.initialize()
  },
  computed: {
    urlAddress,
    ...mapGetters(["USER"]),
  },
  append () {
    this.$refs.uploadInput.click()
  },
  filters: {
    toFixed
  },
  methods: {
    async initialize() {
      await api.getDocuments().then(res => res.data.status && (this.documents = res.data.documents))
    },
    dragOver () {
      this.dropped = 2
    },
    dragLeave () {},
    drop (e) {
      this.file = e.dataTransfer.files[0]
      this.name = this.file.name
    },
    previewFiles(event) {
      this.file = event.currentTarget.files[0]
      this.name = this.file.name
    },
    resetInput() {
      this.file = null
      this.$refs.uploadInput.value = null
    },
    async sendFile () {
      const formData = new FormData()
      formData.append('name', this.name)
      formData.append('url', this.url)
      formData.append('file', this.file)
      await apiAddress().post('/upload-file', formData, {
        headers: {
          // eslint-disable-next-line
          'Authorization': `Bearer ${store.state.token}`,
          'Content-Type': 'multipart/form-data'
        },
        onUploadProgress: function(progressEvent) {
          this.uploadPercentage = parseInt(Math.round(( progressEvent.loaded / progressEvent.total) * 100))
        }.bind(this)
      }).then(res => {
        this.documents.push(res.data.file)
        this.file = null
        this.name = ''
        this.uploadPercentage = 0
      })
    },
    async deleteDocument (doc) {
      const destination = doc.destination.replace('/uploads/documents/', '')
      await api.deleteDocument({_id: doc._id, name: destination}).then(res => {
        if (res.data.status) {
          this.documents = this.documents.filter(el => {
            return el._id !== doc._id
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.documents {
  .delete-btn {
    position: absolute;
    left: 50%;
    top: 100%;
    transform: translate(-50%, -50%);
  }
  .upload {
    .beforeUpload {
      position: relative;
      text-align: center;
      margin-top: 20px;
      padding: 10px 0;
      border-radius: 6px;
      border: 1px dashed gray;
    }
    .beforeUpload input {
      width: 100%;
      margin: auto;
      height: 100%;
      opacity: 0;
      position: absolute;
      background: red;
      display: block;
    }
    .beforeUpload input:hover {
      cursor: pointer;
    }
    .beforeUpload .icon {
      width: 150px;
      margin: auto;
      display: block;
    }
  }
  .docs-wrap {
    .docs {
      img {
        max-width: 100%;
      }
    }
  }
  .file-upload-prev-wrap {
    display: grid;
    overflow: hidden;
    height: calc(100vh - 220px);
  }
  .bottom-gradient {
    background-image: linear-gradient(to top, rgba(0, 0, 0, 0.5) 0%, transparent 72px);
    transition: all .4s;
    &:hover {
      background-image: initial;
    }
  }
}
</style>
